#ifndef _CHUNK_INFO_H_
#define _CHUNK_INFO_H_

#include <stdbool.h>

typedef struct chunk_info {
    void *data;
    int dimensions[2];
    size_t count;
    int y;
    int x;
} chunk_info_t;

extern void chunk_info_init(chunk_info_t *ci, int type, const int dimensions[2], int y, int x, bool allocate_data);

extern void chunk_info_allocate_data(chunk_info_t *ci, int type);

extern void chunk_info_print(chunk_info_t *ci);

extern void chunk_info_free(chunk_info_t *ci);

#endif //_CHUNK_INFO_H_
